<?php

namespace Drupal\templating\Form;



/**
 * Class TemplatingForm.
 */
class TemplatingForm {
    public  static function nodeForm($form){
        $services = \Drupal::service('templating.manager');
        $themes = $services->getThemeList();
        $form['theme'] = [
            '#type' => 'select',
            '#title' => t('Theme'),
            '#options' => array_keys($themes),
            '#required' => TRUE
        ];
        $bundle_list_name = \Drupal::service('entity_type.bundle.info')->getBundleInfo('node');
        $form['bundle'] = [
            '#type' => 'select',
            '#title' => t('Block Custom Type'),
            '#options' => array_keys($bundle_list_name),
            '#required' => TRUE
        ];
        $mode_views = $services::getModeViewList('node');
        $form['mode_view'] = [
            '#type' => 'select',
            '#title' => t('Mode view '),
            '#options' => $mode_views,
            '#required' => TRUE
        ];
        return $form ;

    }

     public static  function blockForm($form){
         $block_type_lists = \Drupal::service('entity.manager')->getStorage('block_content_type')->loadMultiple();
         $block_type = ['none' => 'None'];
         foreach ($block_type_lists as $key => $type) {
             $block_type[$key] = $type->label();
         }
         $block_type_lists = \Drupal::service('entity.manager')->getStorage('block')->loadMultiple();
         $list = [];
         foreach ($block_type_lists as $key => $item) {
             $themes[$item->getTheme()] = $item->getTheme();
             $list[] = $item->getPluginId();
         }
         $defaultThemeName = \Drupal::config('system.theme')->get('default');
         $form['theme'] = [
             '#type' => 'select',
             '#title' => t('Themes'),
             '#options' => $themes,
             '#required' => FALSE,
             '#default_value' => $defaultThemeName
         ];
         $form['blocktype'] = [
             '#type' => 'select',
             '#title' => t('Block Custom Type'),
             '#options' => $block_type,
             '#required' => FALSE
         ];
         $form['blockid'] = [
             '#type' => 'textfield',
             '#title' => t('Plugin ID or Block ID'),
             '#description' => t('Leave empty , if you want to apply for all block'),
         ];

//         $str = "<div class=helper_name >";
//         foreach ($list as $key => $item) {
//             $str = $str . "<ul>";
//             $str = $str . "<li>" . $item . "</li>";
//             $str = $str . "</ul>";
//         }
//         $str = $str . "</div>";
//         $form['filter'] = array(
//             '#type' => 'details',
//             '#title' => t('Help Plugin Name'),
//             '#attributes' => array('class' => array('container-inline')),
//             '#open' => false,
//         );
//         $form['filter']['text'] = [
//             '#type' => 'markup',
//             '#markup' => $str
//         ];
         return $form ;
     }


    public static  function blockFormSubmit($values){
        $config_name = null ;
        if (isset($values['blocktype'])
            && isset($values['blockid']) &&
            isset($values['theme'])) {
            if($values['blockid'] !=""){
                $block_custom = \Drupal::entityTypeManager()->getStorage('block_content')->load(trim($values['blockid']));
                if (is_object($block_custom)) {
                    $block_type = $block_custom->bundle();
                    $config_name = "template.block--".$values['theme']."-". trim($block_type) . "-" .trim($values['blockid'])."-full.html.twig";
                }
            }
            else {
                $config_name = "template.block--".$values['theme'].'-'.trim($values['blocktype'].'-full.html.twig');
            }
        }
        return [
            "name" => $config_name ,
            "type" => "block_content"
        ];
    }


    public static function customForm($form){
        $services = \Drupal::service('templating.manager');
        $themes = $services->getThemeList();
        $form['theme'] = [
              '#type' => 'select',
              '#title' => t('Theme'),
              '#options' => array_keys($themes),
              '#required' => TRUE
        ];
        $form['template_custom'] = [
             '#type' => 'textfield',
             '#title' => t('Template name'),
             '#description' => t('For example : node.platforme_theme.demande.full'),
        ];

         return $form ;
     }
    public static  function customFormSubmit($values){
        return [
            "name" => "template.".$values['template_custom'] ,
            "type" => "custom"
        ];
    }
    public static function defaultContent(){
        return '<div class="templating">{{ content }}</div>';
    }

}
